﻿window.app = window.app || {};

app.viewModel = (function boot(breeze, ko) {

    var core = breeze.core,
        entityModel = breeze.entityModel;

    core.config.setProperties({
        trackingImplementation: entityModel.entityTracking_ko,
        remoteAccessImplementation: entityModel.remoteAccess_webApi
    });

    var serviceName = 'api/breezetest';
    var manager = new entityModel.EntityManager(serviceName);

    var items = ko.observableArray();
    
    var query = new entityModel.EntityQuery().from("items");

    log("Querying ...");
    manager.executeQuery(query)
        .then(querySucceeded)
        .fail(queryFailed);
    
    function querySucceeded(data) {
        log("Query succeeded");
        log(data.results.length + " items from query");
        log(manager.getEntities().length + " entities in cache");
        items(data.results);
    }
    
    function queryFailed(error) {
        log("Query failed: "+error.message);
    }
    
    function log(msg) {
        $('#logmessages').append(msg+"<br/>");
    }

    return {
        items: items
    };

})(breeze, ko);

ko.applyBindings(app.viewModel, $("#content").get(0));
